/* -*- c -*- */

#define _GNU_SOURCE
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <stdbool.h>
#include <math.h>

#ifndef __USE_GNU
#define __USE_GNU
#endif
#include <getopt.h>

#include <coff.h>

#include "utils.h"

int
main(int ac, char *av[])
{
    struct coff_file *coff1 = NULL;
    struct coff_file *coff2 = NULL;
    int c = 1;
    bool verbose = false;

    int opt_index = 0, ch;
    const char *optstring = "+l";
    static const struct option long_opt[] =
    {
        { "verbose", 0, 0, 'l' },
        { 0, 0, 0, 0 }
    };

    while (
        (ch = getopt_long(ac, av, optstring, long_opt, &opt_index)) != -1
    ) {
        switch (ch) {
        case 'l':
            verbose = true;
            break;
        default:
            exit(1);
        }
    }
    ac -= optind;
    av += optind;

    if (ac != 2)
        return 1;

    coff1 = read_coff(av[0]);
    coff2 = read_coff(av[1]);

    if (coff1 && coff2)
        c = compare_coff(coff1, coff2, verbose);

    free_coff(coff1);
    free_coff(coff2);

    return c;
}
