#ifndef _COFF_UTILS_H
#define _COFF_UTILS_H

struct coff_section {
    struct scnhdr head;
    uint32_t      *data;
    struct reloc  *relocs;
    struct lineno *linenos;
};

struct coff_syment {
    struct syment syment;
    char          *name;
};

struct coff_file {
    const char          *name;
    struct filehdr      filehdr;
    struct aouthdr      *aouthdr;
    struct coff_section *sections;
    struct coff_syment  *syments;
    int32_t             str_tab_len;
    char                *str_tab;
};

enum {
    COFF_FILEHDR  = (1 << 0),
    COFF_AOUTHDR  = (1 << 1),
    COFF_SCNS     = (1 << 2),
    COFF_SCNSDATA = (1 << 3),
    COFF_RELOC    = (1 << 4),
    COFF_LNNO     = (1 << 5),
    COFF_SYMTAB   = (1 << 6)
};

extern struct coff_file *read_coff(const char *name);
extern void free_coff(struct coff_file *coff);
extern void print_coff(const struct coff_file *coff, int flags);
extern int compare_coff(struct coff_file *coff1, struct coff_file *coff2,
                        bool keep_going);


#endif /* _COFF_UTILS_H */
