#ifndef _BW_BO_H
#define _BW_BO_H 1

#include <endian.h>
#include <byteswap.h>

#if __BYTE_ORDER == __BIG_ENDIAN

#define bw_le16_to_cpu(x) bswap_16(x)
#define bw_be16_to_cpu(x) (x)

#define bw_le32_to_cpu(x) bswap_32(x)
#define bw_be32_to_cpu(x) (x)

#if defined __GNUC__ && __GNUC__ >= 2

#define bw_le64_to_cpu(x) bswap_64(x)
#define bw_be64_to_cpu(x) (x)

#endif

#elif __BYTE_ORDER == __LITTLE_ENDIAN

#define bw_le16_to_cpu(x) (x)
#define bw_be16_to_cpu(x) bswap_16(x)

#define bw_le32_to_cpu(x) (x)
#define bw_be32_to_cpu(x) bswap_32(x)

#if defined __GNUC__ && __GNUC__ >= 2

#define bw_le64_to_cpu(x) (x)
#define bw_be64_to_cpu(x) bswap_64(x)

#endif

#else
# error unsupported byte order
#endif

#define bw_cpu_to_le16(x) bw_le16_to_cpu(x)
#define bw_cpu_to_be16(x) bw_be16_to_cpu(x)
#define bw_cpu_to_le32(x) bw_le32_to_cpu(x)
#define bw_cpu_to_be32(x) bw_be32_to_cpu(x)
#define bw_cpu_to_le64(x) bw_le64_to_cpu(x)
#define bw_cpu_to_be64(x) bw_be64_to_cpu(x)

#endif /* _BW_BO_H */
