#ifndef _BW_H
#define _BW_H 1

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <stddef.h>
#include <errno.h>

/* provide an ESUCCESS macro */
#ifdef EOK
# define ESUCCESS EOK
#else
# ifdef ENOERROR
#  define ESUCCESS ENOERROR
# else
#  ifdef E_OK
#   define ESUCCESS E_OK
#  endif
# endif
#endif
#ifndef ESUCCESS
# define ESUCCESS 0
#endif

/* stdanard stringify and concat macros */
#define __bw_stringify_1(x) # x
#define __bw_stringify(x)   __bw_stringify_1(x)

#define __bw_concat_1(x, y) x ## y
#define __bw_concat(x, y)   __bw_concat_1(x, y)

/* the famous container_of macro from the linux kernel
 * additionaly check the pointer before decontainerize
 */
#ifndef container_of
/* from linux/include/linux/kernel.h */
#define container_of(ptr, type, member)                         \
({                                                              \
    const typeof(((type *)0)->member) *__mptr = (ptr);          \
    (__mptr)                                                    \
    ? (type *)((const char *)__mptr - offsetof(type, member))   \
    : NULL;                                                     \
})
#endif

/* a shorthand for:
 *  var = container_of(ptr, typeof(*var), member)
 */
#ifndef assign_container_of
#define assign_container_of(var, ptr, member) \
        var = container_of(ptr, typeof(*(var)), member)
#endif

#endif /* _BW_H */
