#ifndef _BW_CMP_H
#define _BW_CMP_H 1

#include <unistd.h>
#include <stdint.h>
#include <stdbool.h>
#include <inttypes.h>

#include "bw.h"

#ifndef __cmp_fn_t_defined
typedef int  (*bw_cmp_fn_t)(const void *, const void *);
# define __cmp_fn_t_defined 1
#endif

#ifndef __iseq_fn_t_defined
typedef bool (*bw_iseq_fn_t)(const void *, const void *);
# define __iseq_fn_t_defined 1
#endif

#define ceq(c) (!(c))
#define cne(c) (!ceq(c))
#define clt(c) ((c) <  0)
#define cle(c) ((c) <= 0)
#define cgt(c) ((c) >  0)
#define cge(c) ((c) >= 0)

#define cnorm(c) ({             \
    int __cn = (c);             \
    (__cn > 0) - (__cn < 0);    \
})

#define eq(f, a, b) ceq((f)(a, b))
#define ne(f, a, b) cne((f)(a, b))
#define lt(f, a, b) clt((f)(a, b))
#define le(f, a, b) cle((f)(a, b))
#define gt(f, a, b) cgt((f)(a, b))
#define ge(f, a, b) cge((f)(a, b))

#endif /* _BW_CMP_H */
