#ifndef _BW_MAX_H
#define _BW_MAX_H 1

#include <stdlib.h>
#include <stdint.h>
#include <inttypes.h>

#define BW_MAX_DECLARE(pre, type)       \
type pre##max(type a, type b)

#define BW_MAX_DEFINE(pre, type)    \
BW_MAX_DECLARE(pre, type)           \
{                                   \
    return (a > b) ? a : b;         \
}

#ifndef __max_defined
static inline BW_MAX_DEFINE(, int)
# define __max_defined 1
#endif

#ifndef __lmax_defined
static inline BW_MAX_DEFINE(l, long)
# define __lmax_defined 1
#endif

#ifndef __llmax_defined
static inline BW_MAX_DEFINE(ll, long long)
# define __llmax_defined 1
#endif

#ifndef __imaxmax_defined
static inline BW_MAX_DEFINE(imax, intmax_t)
# define __imaxmax_defined 1
#endif

#ifndef __iptrmax_defined
static inline BW_MAX_DEFINE(iptr, intptr_t)
# define __iptrmax_defined 1
#endif

#ifndef __i8max_defined
static inline BW_MAX_DEFINE(i8, int8_t)
# define __i8max_defined 1
#endif

#ifndef __i16max_defined
static inline BW_MAX_DEFINE(i16, int16_t)
# define __i16max_defined 1
#endif

#ifndef __i32max_defined
static inline BW_MAX_DEFINE(i32, int32_t)
# define __i32max_defined 1
#endif

#ifndef __i64max_defined
static inline BW_MAX_DEFINE(i64, int64_t)
# define __i64max_defined 1
#endif

#ifndef __szmax_defined
static inline BW_MAX_DEFINE(sz, ssize_t)
# define __szmax_defined 1
#endif

#ifndef __umax_defined
static inline BW_MAX_DEFINE(u, unsigned int)
# define __umax_defined 1
#endif

#ifndef __ulmax_defined
static inline BW_MAX_DEFINE(ul, unsigned long)
# define __ulmax_defined 1
#endif

#ifndef __ullmax_defined
static inline BW_MAX_DEFINE(ull, unsigned long long)
# define __ullmax_defined 1
#endif

#ifndef __umaxmax_defined
static inline BW_MAX_DEFINE(umax, uintmax_t)
# define __umaxmax_defined 1
#endif

#ifndef __uptrmax_defined
static inline BW_MAX_DEFINE(uptr, uintptr_t)
# define __uptrmax_defined 1
#endif

#ifndef __u8max_defined
static inline BW_MAX_DEFINE(u8, uint8_t)
# define __u8max_defined 1
#endif

#ifndef __u16max_defined
static inline BW_MAX_DEFINE(u16, uint16_t)
# define __u16max_defined 1
#endif

#ifndef __u32max_defined
static inline BW_MAX_DEFINE(u32, uint32_t)
# define __u32max_defined 1
#endif

#ifndef __u64max_defined
static inline BW_MAX_DEFINE(u64, uint64_t)
# define __u64max_defined 1
#endif

#ifndef __zmax_defined
static inline BW_MAX_DEFINE(z, size_t)
# define __zmax_defined 1
#endif

#endif /* _BW_MAX_H */
