#ifndef _BW_MIN_H
#define _BW_MIN_H 1

#include <stdlib.h>
#include <stdint.h>
#include <inttypes.h>

#define BW_MIN_DECLARE(pre, type)       \
type pre##min(type a, type b)

#define BW_MIN_DEFINE(pre, type)    \
BW_MIN_DECLARE(pre, type)           \
{                                   \
    return (a < b) ? a : b;         \
}

#ifndef __min_defined
static inline BW_MIN_DEFINE(, int)
# define __min_defined 1
#endif

#ifndef __lmin_defined
static inline BW_MIN_DEFINE(l, long)
# define __lmin_defined 1
#endif

#ifndef __llmin_defined
static inline BW_MIN_DEFINE(ll, long long)
# define __llmin_defined 1
#endif

#ifndef __imaxmin_defined
static inline BW_MIN_DEFINE(imax, intmax_t)
# define __imaxmin_defined 1
#endif

#ifndef __iptrmin_defined
static inline BW_MIN_DEFINE(iptr, intptr_t)
# define __iptrmin_defined 1
#endif

#ifndef __i8min_defined
static inline BW_MIN_DEFINE(i8, int8_t)
# define __i8min_defined 1
#endif

#ifndef __i16min_defined
static inline BW_MIN_DEFINE(i16, int16_t)
# define __i16min_defined 1
#endif

#ifndef __i32min_defined
static inline BW_MIN_DEFINE(i32, int32_t)
# define __i32min_defined 1
#endif

#ifndef __i64min_defined
static inline BW_MIN_DEFINE(i64, int64_t)
# define __i64min_defined 1
#endif

#ifndef __szmin_defined
static inline BW_MIN_DEFINE(sz, ssize_t)
# define __szmin_defined 1
#endif

#ifndef __umin_defined
static inline BW_MIN_DEFINE(u, unsigned int)
# define __umin_defined 1
#endif

#ifndef __ulmin_defined
static inline BW_MIN_DEFINE(ul, unsigned long)
# define __ulmin_defined 1
#endif

#ifndef __ullmin_defined
static inline BW_MIN_DEFINE(ull, unsigned long long)
# define __ullmin_defined 1
#endif

#ifndef __umaxmin_defined
static inline BW_MIN_DEFINE(umax, uintmax_t)
# define __umaxmin_defined 1
#endif

#ifndef __uptrmin_defined
static inline BW_MIN_DEFINE(uptr, uintptr_t)
# define __uptrmin_defined 1
#endif

#ifndef __u8min_defined
static inline BW_MIN_DEFINE(u8, uint8_t)
# define __u8min_defined 1
#endif

#ifndef __u16min_defined
static inline BW_MIN_DEFINE(u16, uint16_t)
# define __u16min_defined 1
#endif

#ifndef __u32min_defined
static inline BW_MIN_DEFINE(u32, uint32_t)
# define __u32min_defined 1
#endif

#ifndef __u64min_defined
static inline BW_MIN_DEFINE(u64, uint64_t)
# define __u64min_defined 1
#endif

#ifndef __zmin_defined
static inline BW_MIN_DEFINE(z, size_t)
# define __zmin_defined 1
#endif

#endif /* _BW_MIN_H */
