#ifndef __PRAMSIM_MEM_STATS_H
#define __PRAMSIM_MEM_STATS_H

#ifdef MOD_MEM_STATS
#include <bw/ht.h>

#define MOD_MEM_STATS_OPTION \
	, { ' ', "mem-stats",    I_STRING(MemStatsFilename), \
	    "collect memory stats to file" },

#define MOD_MEM_STATS_VPREG_MEMBER \
	struct memstats stats;

struct memstats {
	bw_hte_t  hte;
	UWORD     addr;
	uintmax_t count;
	unsigned  type;
};

extern char *MemStatsFilename;
extern void InitMemStats(void);
extern void FiniMemStats(void);
extern void ResetStatMemRequest(struct vpregs *vp);
extern void DoStatMemRequest(struct vpregs *vp);
extern void MarkReadStatMemRequest(struct vpregs *vp);
extern void MarkWriteStatMemRequest(struct vpregs *vp);
extern void OutputMemStats(void);

#else

#define MOD_MEM_STATS_OPTION
#define MOD_MEM_STATS_VPREG_MEMBER

static inline void InitMemStats(void) { }
static inline void FiniMemStats(void) { }
static inline void ResetStatMemRequest(struct vpregs *vp) { (void)vp; }
static inline void DoStatMemRequest(struct vpregs *vp) { (void)vp; }
static inline void MarkReadStatMemRequest(struct vpregs *vp) { (void)vp; }
static inline void MarkWriteStatMemRequest(struct vpregs *vp) { (void)vp; }
static inline void OutputMemStats(void) { }

#endif

#endif /* __PRAMSIM_MEM_STATS_H */
