#ifndef __PRAMSIM_MEM_TRACE_H
#define __PRAMSIM_MEM_TRACE_H

#ifdef MOD_MEM_TRACE

#define MOD_MEM_TRACE_OPTION \
	, { ' ', "mem-trace", I_STRING(MemTraceFilename), \
	    "trace memory requests to file" }

extern char *MemTraceFilename;
extern void InitMemTrace(void);
extern void FiniMemTrace(void);
extern void StartMemTraceOutput(void);
extern void EndMemTraceOutput(void);
extern void DoTraceMemRequest(struct vpregs *vp);

#else

#define MOD_MEM_TRACE_OPTION

static inline void InitMemTrace(void) { }
static inline void FiniMemTrace(void) { }
static inline void StartMemTraceOutput(void) { }
static inline void EndMemTraceOutput(void) { }
static inline void DoTraceMemRequest(struct vpregs *vp) { (void)vp; }

#endif

#endif /* __PRAMSIM_MEM_TRACE_H */
