#ifndef _PRASS_COFF_H
#define _PRASS_COFF_H

#include <coff.h>

#define COFF_BLK_SIZE 128

struct sym {
    struct syment se;
    char *name;
};

#define MAKE_BLK(tag)                           \
struct tag##_blk                                \
{                                               \
	struct tag       entry[COFF_BLK_SIZE];  \
	struct tag##_blk *next;                 \
}

MAKE_BLK(reloc);
MAKE_BLK(sym);
MAKE_BLK(lineno);

struct section_blk
{
	int32_t            entry[COFF_BLK_SIZE];
	struct section_blk *next;
};

struct section
{
	struct scnhdr      head;         /* section header */
	int32_t            sbp_flags;    /* only for sbp */
	int32_t            section_nr;   /* section Number */
	int32_t            symndx;
	struct section_blk *data;        /* pointer to section data */
	struct section_blk *data_start;  /* pointer to the first block */
	struct reloc_blk   *relocate;
	struct reloc_blk   *reloc_start;
	struct lineno_blk  *lineno;
	struct lineno_blk  *lineno_start;
	struct section     *next;        /* pointer to the next section */
};

#define SBP_SHARED  INT32_C(0x1)
#define SBP_PRIVATE INT32_C(0x2)

#endif /* _PRASS_COFF_H */
